/* autolinas_dss.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autolinas_predefined.h"
#include "autolinas.h"

#include "autolinas_measure_inside.h"
#include "autolinas_system_inside.h"
#include "autolinas_dss_inside.h"



/* module variables */

double SVModified[System_maxDofs];



void AutoLinAS_Initialize 
(int nNodes)
{
  AutoLinAS_INSIDE_InitializeSystem (nNodes);
  AutoLinAS_INSIDE_InitializeMatrix ();
}

void AutoLinAS_Fix (void)
{
  AutoLinAS_INSIDE_SetDirichletCondition ();

#ifdef MEASURE_TIME
  AutoLinAS_InitializeMeasure ();
#endif

  AutoLinAS_INSIDE_Factorize ();

#ifdef MEASURE_TIME
  AutoLinAS_TerminateMeasure ();
#endif
}

void AutoLinAS_Solve (void)
{
  int iDof;

  for (iDof = 0; iDof < System_nDofs; iDof++) {
    SV1[iDof] = SV0[iDof];
    SV1[iDof] += SVModified[iDof];
    if (SVFixedFlag[iDof]) {
      SV1[iDof] = SVFixed[iDof];
    }
  }

  AutoLinAS_INSIDE_Solve ();
}

void AutoLinAS_SolveUsingInitialResult (void)
{
  AutoLinAS_Solve ();
}
