/* autolinas_ldl.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autolinas_predefined.h"
#include "autolinas.h"

#include "autolinas_measure_inside.h"
#include "autolinas_system_inside.h"
#include "autolinas_ldl_inside.h"



/* module variables */

double SVModified[System_maxDofs];



void AutoLinAS_Initialize 
(int nNodes, 
 int nElements, 
 ElementNodeIdCallbackType callback)
{
  AutoLinAS_INSIDE_InitializeSystem (nNodes, nElements, callback);
  AutoLinAS_INSIDE_InitializeMatrix ();
}

void AutoLinAS_Fix (void)
{
  int iElement;

  AutoLinAS_INSIDE_Clear ();

  for (iElement = 0; iElement < System_nElements; iElement++) {
    AutoLinAS_INSIDE_AssembleElementMatrix (iElement);
  }

  AutoLinAS_INSIDE_SetDirichletCondition ();

#ifdef MEASURE_TIME
  AutoLinAS_InitializeMeasure ();
#endif

  AutoLinAS_INSIDE_LDLDecomposition ();

#ifdef MEASURE_TIME
  AutoLinAS_TerminateMeasure ();
#endif
}

void AutoLinAS_Solve (void)
{
  int iDof;

  for (iDof = 0; iDof < System_nDofs; iDof++) {
    SV1[iDof] = SV0[iDof];
    if (SVFixedFlag[iDof]) {
      SV1[iDof] = SVModified[iDof];
    }
  }

  AutoLinAS_INSIDE_ForwardReduction ();
  AutoLinAS_INSIDE_BackwardSubstitution ();
}

void AutoLinAS_SolveUsingInitialResult (void)
{
  AutoLinAS_Solve ();
}
