/* autolinas_ldl_full_outer.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autolinas_predefined.h"
#include "autolinas.h"

#include "autolinas_measure_inside.h"
#include "autolinas_system_inside.h"
#include "autolinas_ldl_inside.h"
#include "autolinas_ldl_full_inside.h"



/* symmetric matrix */
/* direct method, LtDL decomposition */
/* outer product Gauss form (KIJ) */
/* full matrix */



void AutoLinAS_INSIDE_LDLDecomposition (void)
{
  int iDof, jDof, kDof;

  for (iDof = 0; iDof < System_nDofs - 1; iDof++) {

    for (jDof = iDof + 1; jDof < System_nDofs; jDof++) {
      double t = SM[jDof][iDof] / SM[iDof][iDof];

      for (kDof = iDof + 1; kDof < System_nDofs; kDof++) {
	SM[jDof][kDof] -= t * SM[iDof][kDof];
      }
    }
  }
}

void AutoLinAS_INSIDE_ForwardReduction (void)
{
  int iDof, jDof;

  for (iDof = 0; iDof < System_nDofs - 1; iDof++) {

    for (jDof = iDof + 1; jDof < System_nDofs; jDof++) {
      double t = SM[jDof][iDof] / SM[iDof][iDof];

      SV1[jDof] -= t * SV1[iDof];
    }
  }
}

void AutoLinAS_INSIDE_BackwardSubstitution (void)
{
  int iDof, jDof;

  SV1[System_nDofs - 1] /= SM[System_nDofs - 1][System_nDofs - 1];

  for (iDof = System_nDofs - 2; 0 <= iDof; iDof--) {

    for (jDof = iDof + 1; jDof < System_nDofs; jDof++) {
      SV1[iDof] -= SM[jDof][iDof] * SV1[jDof];
    }

    SV1[iDof] /= SM[iDof][iDof];
  }
}

