/* header file for autolinas_measure.h */

/* measure memory usage, time, operation count, I/O count etc. */

#if 1
#define MEASURE
#endif

#if 1
#define MEASURE_TIME
#endif

void AutoLinAS_InitializeMeasure (void);
void AutoLinAS_TerminateMeasure (void);

void AutoLinAS_ClearTime (void);
double AutoLinAS_GetTime (void);

void AutoLinAS_CountTime (int counterId);
void AutoLinAS_DivideTimeCounters (double value);
void AutoLinAS_PrintTimeCounters (void);

/* operation type */
#define M_ADD_OP 0
#define M_MUL_OP 1
#define M_OTHER_OP 2

void AutoLinAS_ClearOp (void);
void AutoLinAS_AddOp (int opType, double count);
double AutoLinAS_GetOp (int opType);

/* I/O level */
#define M_MEMORY 0
#define M_CACHE 1
#define M_DISK 2

void AutoLinAS_ClearIO (void);
void AutoLinAS_AddIO (int level, double count);
double AutoLinAS_GetIO (int level);
