/* header file for autolinas.c */

void AutoLinAS_Initialize 
(int nNodes);

void AutoLinAS_RegisterNodalIndex (int iNode, int jNode);

void AutoLinAS_AllocateMatrix (void);

/* {x_fixed} = {0} */
void AutoLinAS_ClearConstraint (void);

/* {x_fixed}[iNode][iDof_Node] = value */ 
void AutoLinAS_SetConstraint
(int iNode, int iDof_Node, double value);

/* [A] = [0] */
void AutoLinAS_ClearMatrix (void);

/* [A] += [m] */
void AutoLinAS_AssembleNodalMatrix 
(int iNode, int jNode,
 double matrix[Node_nDofs][Node_nDofs]);

/* apply constraint and prepare solving */
void AutoLinAS_Fix (void);

/* {b} = {0} */
void AutoLinAS_ClearRightHandSide (void);

/* {b}[iNode][iDof_Node] += value */ 
void AutoLinAS_AddRightHandSide
(int iNode, int iDof_Node, double value);

/* {x_initial} = {0} */
void AutoLinAS_ClearInitialResult (void);

/* {x_initial} = {x} */
void AutoLinAS_CopyResultToInitialResult (void);

/* {x_initial}[iNode][iDof_Node] = value */ 
void AutoLinAS_SetInitialResult
(int iNode, int iDof_Node, double value);

/* solve {x} of equation [A]{x} == {b} */
/* with constraint {x_fixed} */
void AutoLinAS_Solve (void);

/* solve {x} of equation [A]{x} == {b} */
/* with constraint {x_fixed} */
/* initial value of {x} is {x_initial} */
void AutoLinAS_SolveUsingInitialResult (void);

/* get component of {x} */
double AutoLinAS_Result (int iNode, int iDof_Node);



