/* autolinas_ldl_full_profile.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>

#include "autolinas_predefined.h"
#include "autolinas.h"

#include "autolinas_measure_inside.h"
#include "autolinas_system_inside.h"
#include "autolinas_ldl_inside.h"
#include "autolinas_ldl_full_inside.h"



/* symmetric matrix */
/* direct method, LtDL decomposition */
/* profile form (IJK) */
/* full matrix */



void AutoLinAS_INSIDE_LDLDecomposition (void)
{
  int iDof, jDof, kDof;

  for (iDof = 0; iDof < System_nDofs; iDof++) {

    for (jDof = 0; jDof < iDof; jDof++) {

      for (kDof = 0; kDof < jDof; kDof++) {
        SM[iDof][jDof] 
	  -= SM[iDof][kDof] * SM[jDof][kDof] * SM[kDof][kDof];
      }

      SM[iDof][jDof] /= SM[jDof][jDof];
    }

    for (jDof = 0; jDof < iDof; jDof++) {
      SM[iDof][iDof] 
	-= SM[iDof][jDof] * SM[iDof][jDof] * SM[jDof][jDof]; 
    }
  }
}

void AutoLinAS_INSIDE_ForwardReduction (void)
{
  int iDof, jDof;

  for (iDof = 0; iDof < System_nDofs; iDof++) {

    for (jDof = 0; jDof < iDof; jDof++) {
      SV1[iDof] -= SM[iDof][jDof] * SV1[jDof];
    }
  }
}

void AutoLinAS_INSIDE_BackwardSubstitution (void)
{
  int iDof, jDof;

  SV1[System_nDofs - 1] /= SM[System_nDofs - 1][System_nDofs - 1];

  for (iDof = System_nDofs - 2; 0 <= iDof; iDof--) {
    SV1[iDof] /= SM[iDof][iDof];

    for (jDof = iDof + 1; jDof < System_nDofs; jDof++) {
      SV1[iDof] -= SM[jDof][iDof] * SV1[jDof];
    }
  }
}

