/* header file for es_3d_tetra.c */



/* Material */

/* 3D solid */

/* gravity force vector */
extern double Material_gVec[Node_nDofs];

/* young's modulus */
extern double Material_E;

/* poisson ratio */
extern double Material_nyu;

/* mass density */
extern double Material_rou;



/* Node */

/* 3D solid, linear elastic */

extern int Node_nNodes;

/* global coordinate */
extern double Node_XVec[Node_maxNodes][Space_nDimensions];

/* displacement boundary condition */
extern int Node_u_BCVecFlag[Node_maxNodes][Node_nDofs];
extern double Node_u_BCVec[Node_maxNodes][Node_nDofs];

/* concentrated load boundary condition */
extern int Node_f_BCVecFlag[Node_maxNodes][Node_nDofs];
extern double Node_f_BCVec[Node_maxNodes][Node_nDofs];

/* displacement analysis result */
extern double Node_uVec[Node_maxNodes][Node_nDofs];

/* nodal equivalent stress analysis result */
extern double Node_sigma_eq[Node_maxNodes];

/* weight parameter for averaging on node */
extern double Node_weight[Node_maxNodes];



/* Element */

/* 3D solid, linear elastic */

#define Element_maxElements 1000000
#define Element_nDofs (Node_nDofs * Element_nNodes)

extern int Element_nElements;

/* connectivity */
extern int Element_nodeIds[Element_maxElements][Element_nNodes];

/* stiffness matrix */
void Element_KMat
(int iElement,
 double RETURN_VALUE[Element_nDofs][Element_nDofs]);

/* body force vector */
void Element_f_bVec
(int iElement,
 double RETURN_VALUE[Element_nDofs]);

/* calculate nodal equivalent stress */
void Element_calculate_sigma_eq
(int iElement);

