c     
      implicit none

      integer MAX_NODES
      parameter (MAX_NODES = 1000)
      integer MAX_ELEMENTS
      parameter (MAX_ELEMENTS = 1000)
      integer N_ELEMENT_NODES
      parameter (N_ELEMENT_NODES = 3)

      integer n_nodes
      integer n_elements
      integer node_ids(MAX_ELEMENTS, N_ELEMENT_NODES)
      double precision t(4)
      double precision nm(1, 1)
      double precision matrix(3, 3)

      integer ie, in, ien, jen
      integer node_id1, node_id2

      n_nodes = 4
      n_elements = 2

      node_ids(1,1) = 1
      node_ids(1,2) = 2
      node_ids(1,3) = 4
      
      node_ids(2,1) = 4
      node_ids(2,2) = 3
      node_ids(2,3) = 1

      matrix(1,1) = 2.0d0;
      matrix(2,2) = 2.0d0;
      matrix(3,3) = 2.0d0;

      matrix(1,2) = -1.0d0;
      matrix(1,3) = -1.0d0;
      matrix(2,1) = -1.0d0;
      matrix(2,3) = -1.0d0;
      matrix(3,1) = -1.0d0;
      matrix(3,2) = -1.0d0;

      call autolinas_initialize(n_nodes)

      do ie = 1, n_elements

         do ien = 1, 3
            node_id1 = node_ids(ie, ien)
            do jen = 1, 3
               node_id2 = node_ids(ie, jen)

               call autolinas_register_nodal_index
     c              (node_id1, node_id2)
            enddo
         enddo
      enddo

      call autolinas_allocate_matrix()

      call autolinas_clear_constraint()
      call autolinas_set_constraint(1, 1, 0.0d0)
      call autolinas_set_constraint(4, 1, 100.0d0)

      call autolinas_clear_right_hand_side()
c     call autolinas_add_right_hand_side(2, 1, 1.0d0)

      call autolinas_clear_matrix()

      do ie = 1, n_elements

         do ien = 1, 3
            node_id1 = node_ids(ie, ien)
            do jen = 1, 3
               node_id2 = node_ids(ie, jen)
               
               nm(1,1) = matrix(ien, jen)
               call autolinas_assemble_nodal_matrix
     c              (node_id1, node_id2, nm)
            enddo
         enddo
      enddo

      call autolinas_fix()

      call autolinas_solve()

      do in = 1, n_nodes
         call autolinas_result(in, 1, t(in))
      enddo

      do in = 1, n_nodes
         write(*,*) t(in)
      enddo

      end
